// ==============================================================
// File generated by Xilinx Model Composer(TM)
// Version: 2020.2
//  
// (c) Copyright 2017 - 2020 Xilinx, Inc. All rights reserved.
//  
// This file contains confidential and proprietary information
// of Xilinx, Inc. and is protected under U.S. and
// international copyright and other intellectual property
// laws.
//  
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// Xilinx, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) Xilinx shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the
// possibility of the same.
//  
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of Xilinx products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
//  
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES.
// ==============================================================
#include "XMC_grid_sync.h"
#include <xmcHlsMath.h>
#include <ap_shift_reg.h>
#include <xmcArithBasics.h>
#include <xmcArithDivide.h>
#include <xmcArithSatBasics.h>
#include <StreamAdapters.h>
void
XMC_grid_sync_core(float Ig_A, float Ig_B, float Ig_C, float Ug_A, float Ug_B, 
    float Ug_C, float Ts, float* Ig_d, float* Ig_q, float* Ig_zero, float* Ug_d
    , float* Ug_q, float* Ug_zero, float* theta, float* freq)
{
    #pragma HLS inline
    float Unit_Delay1_out1;
    float Unit_Delay3_out1;
    float Delay_out1;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Data_Type_Conversion_out1;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Data_Type_Conversion1_out1;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Data_Type_Conversion2_out1;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Data_Type_Conversion_out1_0;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Data_Type_Conversion1_out1_0;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Data_Type_Conversion2_out1_0;
    ap_fixed<16,4,AP_TRN,AP_WRAP,0> Data_Type_Conversion6_out1;
    ap_fixed<16,4,AP_TRN,AP_WRAP,0> Data_Type_Conversion6_out1_0;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Gain_out1;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Gain1_out1;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Gain2_out1;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Gain3_out1;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Gain4_out1;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Gain5_out1;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Gain_out1_0;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Gain1_out1_0;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Gain2_out1_0;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Gain3_out1_0;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Gain4_out1_0;
    ap_fixed<32,16,AP_TRN,AP_WRAP,0> Gain5_out1_0;
    float Constant_out1;
    float Constant1_out1;
    float Constant2_out1;
    float Constant3_out1;
    float Constant4_out1;
    ap_fixed<14,2,AP_TRN,AP_WRAP,0> Cosine_out1;
    ap_fixed<14,2,AP_TRN,AP_WRAP,0> Sine_out1;
    ap_fixed<14,2,AP_TRN,AP_WRAP,0> Cosine_out1_0;
    ap_fixed<14,2,AP_TRN,AP_WRAP,0> Sine_out1_0;
    ap_fixed<33,17,AP_TRN,AP_WRAP,0> Subtract_out1;
    ap_fixed<33,17,AP_TRN,AP_WRAP,0> Sum_out1;
    ap_fixed<33,17,AP_TRN,AP_WRAP,0> Subtract2_out1;
    ap_fixed<33,17,AP_TRN,AP_WRAP,0> Subtract_out1_0;
    ap_fixed<33,17,AP_TRN,AP_WRAP,0> Sum_out1_0;
    ap_fixed<33,17,AP_TRN,AP_WRAP,0> Subtract2_out1_0;
    float Product_out1;
    ap_fixed<34,18,AP_TRN,AP_WRAP,0> Subtract1_out1;
    ap_fixed<34,18,AP_TRN,AP_WRAP,0> Sum1_out1;
    ap_fixed<47,19,AP_TRN,AP_WRAP,0> Product1_out1;
    ap_fixed<47,19,AP_TRN,AP_WRAP,0> Product3_out1;
    ap_fixed<34,18,AP_TRN,AP_WRAP,0> Subtract1_out1_0;
    ap_fixed<34,18,AP_TRN,AP_WRAP,0> Sum1_out1_0;
    ap_fixed<47,19,AP_TRN,AP_WRAP,0> Product1_out1_0;
    ap_fixed<47,19,AP_TRN,AP_WRAP,0> Product3_out1_0;
    ap_fixed<48,20,AP_TRN,AP_WRAP,0> Product_out1_0;
    ap_fixed<48,20,AP_TRN,AP_WRAP,0> Product2_out1;
    ap_fixed<48,20,AP_TRN,AP_WRAP,0> Product_out1_1;
    ap_fixed<48,20,AP_TRN,AP_WRAP,0> Product2_out1_0;
    ap_fixed<49,21,AP_TRN,AP_WRAP,0> Sum2_out1;
    ap_fixed<49,21,AP_TRN,AP_WRAP,0> Subtract3_out1;
    ap_fixed<49,21,AP_TRN,AP_WRAP,0> Sum2_out1_0;
    ap_fixed<49,21,AP_TRN,AP_WRAP,0> Subtract3_out1_0;
    float Data_Type_Conversion4_out1;
    float Product_out1_2;
    float Product1_out1_1;
    float Sum_out1_1;
    float Sum1_out1_1;
    float Sum2_out1_1;
    float Product1_out1_2;
    float Sum1_out1_2;
    bool Greater_out1;
    bool Lesser_out1;
    float Subtract_out1_1;
    float Sum4_out1;
    bool Conditional_cmp_out;
    bool Conditional1_cmp_out;
    float Conditional_out1;
    float Conditional1_out1;
    bool Conditional_thr_out = false;
    bool Conditional1_thr_out = false;
    float Constant_c = 5.000000000e+00f;
    float Constant1_c = 2.000000000e+00f;
    float Constant2_c = 3.141592712e+02f;
    float Constant3_c = 6.283185482e+00f;
    float Constant4_c = 0.000000000e+00f;
    static ap_shift_reg<float, 1> Delay_q;
    #pragma HLS reset variable=Delay_q
    static float Unit_Delay1_q = 0.000000000e+00f;
    #pragma HLS reset variable=Unit_Delay1_q
    static float Unit_Delay3_q = 0.000000000e+00f;
    #pragma HLS reset variable=Unit_Delay3_q
    Unit_Delay1_out1 = Unit_Delay1_q;
    Unit_Delay3_out1 = Unit_Delay3_q;
    static uint32_t Delay_init_count_down = 1u;
    #pragma HLS reset variable=Delay_init_count_down
    float Delay_tmp(0);
    if (!Delay_init_count_down) {
        Delay_tmp = Delay_q.read();
    }
    Delay_out1 = Delay_tmp;
    if (Delay_init_count_down) {
        --Delay_init_count_down;
    }
    Data_Type_Conversion_out1 = 
        xmc::arith::convert< ap_fixed<32,16,AP_TRN,AP_WRAP,0> >(Ig_A);
    Data_Type_Conversion1_out1 = 
        xmc::arith::convert< ap_fixed<32,16,AP_TRN,AP_WRAP,0> >(Ig_B);
    Data_Type_Conversion2_out1 = 
        xmc::arith::convert< ap_fixed<32,16,AP_TRN,AP_WRAP,0> >(Ig_C);
    Data_Type_Conversion_out1_0 = 
        xmc::arith::convert< ap_fixed<32,16,AP_TRN,AP_WRAP,0> >(Ug_A);
    Data_Type_Conversion1_out1_0 = 
        xmc::arith::convert< ap_fixed<32,16,AP_TRN,AP_WRAP,0> >(Ug_B);
    Data_Type_Conversion2_out1_0 = 
        xmc::arith::convert< ap_fixed<32,16,AP_TRN,AP_WRAP,0> >(Ug_C);
    *theta = Unit_Delay1_out1;
    Data_Type_Conversion6_out1 = 
        xmc::arith::convert< ap_fixed<16,4,AP_TRN,AP_WRAP,0> >(Unit_Delay1_out1
        );
    Data_Type_Conversion6_out1_0 = 
        xmc::arith::convert< ap_fixed<16,4,AP_TRN,AP_WRAP,0> >(Unit_Delay1_out1
        );
    float Gain_const = 6.666666865e-01f;
    xmc::arith::convert(Gain_out1, xmc::arith::mul< float >(
        Data_Type_Conversion_out1, Gain_const));
    float Gain1_const = 3.333333433e-01f;
    xmc::arith::convert(Gain1_out1, xmc::arith::mul< float >(
        Data_Type_Conversion_out1, Gain1_const));
    float Gain2_const = 5.773502588e-01f;
    xmc::arith::convert(Gain2_out1, xmc::arith::mul< float >(
        Data_Type_Conversion1_out1, Gain2_const));
    float Gain3_const = 3.333333433e-01f;
    xmc::arith::convert(Gain3_out1, xmc::arith::mul< float >(
        Data_Type_Conversion1_out1, Gain3_const));
    float Gain4_const = 5.773502588e-01f;
    xmc::arith::convert(Gain4_out1, xmc::arith::mul< float >(
        Data_Type_Conversion2_out1, Gain4_const));
    float Gain5_const = 3.333333433e-01f;
    xmc::arith::convert(Gain5_out1, xmc::arith::mul< float >(
        Data_Type_Conversion2_out1, Gain5_const));
    float Gain_const_0 = 6.666666865e-01f;
    xmc::arith::convert(Gain_out1_0, xmc::arith::mul< float >(
        Data_Type_Conversion_out1_0, Gain_const_0));
    float Gain1_const_0 = 3.333333433e-01f;
    xmc::arith::convert(Gain1_out1_0, xmc::arith::mul< float >(
        Data_Type_Conversion_out1_0, Gain1_const_0));
    float Gain2_const_0 = 5.773502588e-01f;
    xmc::arith::convert(Gain2_out1_0, xmc::arith::mul< float >(
        Data_Type_Conversion1_out1_0, Gain2_const_0));
    float Gain3_const_0 = 3.333333433e-01f;
    xmc::arith::convert(Gain3_out1_0, xmc::arith::mul< float >(
        Data_Type_Conversion1_out1_0, Gain3_const_0));
    float Gain4_const_0 = 5.773502588e-01f;
    xmc::arith::convert(Gain4_out1_0, xmc::arith::mul< float >(
        Data_Type_Conversion2_out1_0, Gain4_const_0));
    float Gain5_const_0 = 3.333333433e-01f;
    xmc::arith::convert(Gain5_out1_0, xmc::arith::mul< float >(
        Data_Type_Conversion2_out1_0, Gain5_const_0));
    Constant_out1 = Constant_c;
    Constant1_out1 = Constant1_c;
    Constant2_out1 = Constant2_c;
    Constant3_out1 = Constant3_c;
    Constant4_out1 = Constant4_c;
    Cosine_out1 = XMC_HLS_COS(Data_Type_Conversion6_out1);
    Sine_out1 = XMC_HLS_SIN(Data_Type_Conversion6_out1);
    Cosine_out1_0 = XMC_HLS_COS(Data_Type_Conversion6_out1_0);
    Sine_out1_0 = XMC_HLS_SIN(Data_Type_Conversion6_out1_0);
    xmc::arith::sub(Subtract_out1, Gain_out1, Gain3_out1);
    xmc::arith::add(Sum_out1, Gain1_out1, Gain3_out1);
    xmc::arith::sub(Subtract2_out1, Gain2_out1, Gain4_out1);
    xmc::arith::sub(Subtract_out1_0, Gain_out1_0, Gain3_out1_0);
    xmc::arith::add(Sum_out1_0, Gain1_out1_0, Gain3_out1_0);
    xmc::arith::sub(Subtract2_out1_0, Gain2_out1_0, Gain4_out1_0);
    xmc::arith::mul(Product_out1, Constant1_out1, Ts);
    xmc::arith::sub(Subtract1_out1, Subtract_out1, Gain5_out1);
    xmc::arith::add(Sum1_out1, Sum_out1, Gain5_out1);
    xmc::arith::mul(Product1_out1, Subtract2_out1, Sine_out1);
    xmc::arith::mul(Product3_out1, Subtract2_out1, Cosine_out1);
    xmc::arith::sub(Subtract1_out1_0, Subtract_out1_0, Gain5_out1_0);
    xmc::arith::add(Sum1_out1_0, Sum_out1_0, Gain5_out1_0);
    xmc::arith::mul(Product1_out1_0, Subtract2_out1_0, Sine_out1_0);
    xmc::arith::mul(Product3_out1_0, Subtract2_out1_0, Cosine_out1_0);
    xmc::arith::mul(Product_out1_0, Subtract1_out1, Cosine_out1);
    xmc::arith::mul(Product2_out1, Subtract1_out1, Sine_out1);
    *Ig_zero = xmc::arith::convert< float >(Sum1_out1);
    xmc::arith::mul(Product_out1_1, Subtract1_out1_0, Cosine_out1_0);
    xmc::arith::mul(Product2_out1_0, Subtract1_out1_0, Sine_out1_0);
    *Ug_zero = xmc::arith::convert< float >(Sum1_out1_0);
    xmc::arith::add(Sum2_out1, Product_out1_0, Product1_out1);
    xmc::arith::sub(Subtract3_out1, Product3_out1, Product2_out1);
    xmc::arith::add(Sum2_out1_0, Product_out1_1, Product1_out1_0);
    xmc::arith::sub(Subtract3_out1_0, Product3_out1_0, Product2_out1_0);
    *Ig_d = xmc::arith::convert< float >(Sum2_out1);
    *Ig_q = xmc::arith::convert< float >(Subtract3_out1);
    *Ug_d = xmc::arith::convert< float >(Sum2_out1_0);
    Data_Type_Conversion4_out1 = xmc::arith::convert< float >(Subtract3_out1_0)
        ;
    *Ug_q = Data_Type_Conversion4_out1;
    xmc::arith::mul(Product_out1_2, Data_Type_Conversion4_out1, Constant_out1);
    xmc::arith::mul(Product1_out1_1, Data_Type_Conversion4_out1, Product_out1);
    xmc::arith::add(Sum_out1_1, Product_out1_2, Delay_out1);
    xmc::arith::add(Sum1_out1_1, Product1_out1_1, Delay_out1);
    xmc::arith::add(Sum2_out1_1, Sum_out1_1, Constant2_out1);
    Delay_q.shift(Sum1_out1_1, 0);
    xmc::arith::mul(Product1_out1_2, Sum2_out1_1, Ts);
    *freq = Sum2_out1_1;
    xmc::arith::add(Sum1_out1_2, Product1_out1_2, Unit_Delay3_out1);
    Greater_out1 = Sum1_out1_2 > Constant3_out1;
    Lesser_out1 = Sum1_out1_2 < Constant4_out1;
    xmc::arith::sub(Subtract_out1_1, Sum1_out1_2, Constant3_out1);
    xmc::arith::add(Sum4_out1, Sum1_out1_2, Constant3_out1);
    Conditional_cmp_out = Greater_out1 != Conditional_thr_out;
    Conditional1_cmp_out = Lesser_out1 != Conditional1_thr_out;
    Conditional_out1 = Conditional_cmp_out ? Subtract_out1_1 : Sum1_out1_2;
    Conditional1_out1 = Conditional1_cmp_out ? Sum4_out1 : Conditional_out1;
    Unit_Delay1_q = Conditional1_out1;
    Unit_Delay3_q = Conditional1_out1;
}

/**
 * @brief XMC_grid_sync
 * @param Ig_A direction=input protocol=AXI4-Stream length=1
 * @param Ig_B direction=input protocol=AXI4-Stream length=1
 * @param Ig_C direction=input protocol=AXI4-Stream length=1
 * @param Ug_A direction=input protocol=AXI4-Stream length=1
 * @param Ug_B direction=input protocol=AXI4-Stream length=1
 * @param Ug_C direction=input protocol=AXI4-Stream length=1
 * @param Ts direction=input protocol=AXI4-Stream length=1
 * @param Ig_d direction=output protocol=AXI4-Stream length=1
 * @param Ig_q direction=output protocol=AXI4-Stream length=1
 * @param Ig_zero direction=output protocol=AXI4-Stream length=1
 * @param Ug_d direction=output protocol=AXI4-Stream length=1
 * @param Ug_q direction=output protocol=AXI4-Stream length=1
 * @param Ug_zero direction=output protocol=AXI4-Stream length=1
 * @param theta direction=output protocol=AXI4-Stream length=1
 * @param freq direction=output protocol=AXI4-Stream length=1
 */
void
XMC_grid_sync(hls::stream< float >& Ig_A, hls::stream< float >& Ig_B, 
    hls::stream< float >& Ig_C, hls::stream< float >& Ug_A, 
    hls::stream< float >& Ug_B, hls::stream< float >& Ug_C, 
    hls::stream< float >& Ts, hls::stream< float >& Ig_d, hls::stream< float >&
     Ig_q, hls::stream< float >& Ig_zero, hls::stream< float >& Ug_d, 
    hls::stream< float >& Ug_q, hls::stream< float >& Ug_zero, 
    hls::stream< float >& theta, hls::stream< float >& freq)
{
    #pragma HLS INTERFACE axis port=Ig_A
    #pragma HLS INTERFACE axis port=Ig_B
    #pragma HLS INTERFACE axis port=Ig_C
    #pragma HLS INTERFACE axis port=Ug_A
    #pragma HLS INTERFACE axis port=Ug_B
    #pragma HLS INTERFACE axis port=Ug_C
    #pragma HLS INTERFACE axis port=Ts
    #pragma HLS INTERFACE axis port=Ig_d
    #pragma HLS INTERFACE axis port=Ig_q
    #pragma HLS INTERFACE axis port=Ig_zero
    #pragma HLS INTERFACE axis port=Ug_d
    #pragma HLS INTERFACE axis port=Ug_q
    #pragma HLS INTERFACE axis port=Ug_zero
    #pragma HLS INTERFACE axis port=theta
    #pragma HLS INTERFACE axis port=freq
    #pragma HLS INTERFACE ap_ctrl_none port=return

    float Ig_A_adapter_out1;
    float Ig_B_adapter_out1;
    float Ig_C_adapter_out1;
    float Ug_A_adapter_out1;
    float Ug_B_adapter_out1;
    float Ug_C_adapter_out1;
    float Ts_adapter_out1;
    float XMC_grid_sync_core_Ig_d;
    float XMC_grid_sync_core_Ig_q;
    float XMC_grid_sync_core_Ig_zero;
    float XMC_grid_sync_core_Ug_d;
    float XMC_grid_sync_core_Ug_q;
    float XMC_grid_sync_core_Ug_zero;
    float XMC_grid_sync_core_theta;
    float XMC_grid_sync_core_freq;
    xmc::StreamAdapter::readStream(Ig_A, &Ig_A_adapter_out1);
    xmc::StreamAdapter::readStream(Ig_B, &Ig_B_adapter_out1);
    xmc::StreamAdapter::readStream(Ig_C, &Ig_C_adapter_out1);
    xmc::StreamAdapter::readStream(Ug_A, &Ug_A_adapter_out1);
    xmc::StreamAdapter::readStream(Ug_B, &Ug_B_adapter_out1);
    xmc::StreamAdapter::readStream(Ug_C, &Ug_C_adapter_out1);
    xmc::StreamAdapter::readStream(Ts, &Ts_adapter_out1);
    XMC_grid_sync_core(Ig_A_adapter_out1, Ig_B_adapter_out1, Ig_C_adapter_out1,
         Ug_A_adapter_out1, Ug_B_adapter_out1, Ug_C_adapter_out1, 
        Ts_adapter_out1, &XMC_grid_sync_core_Ig_d, &XMC_grid_sync_core_Ig_q, &
        XMC_grid_sync_core_Ig_zero, &XMC_grid_sync_core_Ug_d, &
        XMC_grid_sync_core_Ug_q, &XMC_grid_sync_core_Ug_zero, &
        XMC_grid_sync_core_theta, &XMC_grid_sync_core_freq);
    xmc::StreamAdapter::writeStream(Ig_d, XMC_grid_sync_core_Ig_d);
    xmc::StreamAdapter::writeStream(Ig_q, XMC_grid_sync_core_Ig_q);
    xmc::StreamAdapter::writeStream(Ig_zero, XMC_grid_sync_core_Ig_zero);
    xmc::StreamAdapter::writeStream(Ug_d, XMC_grid_sync_core_Ug_d);
    xmc::StreamAdapter::writeStream(Ug_q, XMC_grid_sync_core_Ug_q);
    xmc::StreamAdapter::writeStream(Ug_zero, XMC_grid_sync_core_Ug_zero);
    xmc::StreamAdapter::writeStream(theta, XMC_grid_sync_core_theta);
    xmc::StreamAdapter::writeStream(freq, XMC_grid_sync_core_freq);
}


