#include <systemc>
#include <iostream>
#include <cstdlib>
#include <cstddef>
#include <stdint.h>
#include "SysCFileHandler.h"
#include "ap_int.h"
#include "ap_fixed.h"
#include <complex>
#include <stdbool.h>
#include "autopilot_cbe.h"
#include "hls_stream.h"
#include "hls_half.h"
#include "hls_signal_handler.h"

using namespace std;
using namespace sc_core;
using namespace sc_dt;

// wrapc file define:
#define AUTOTB_TVIN_Ig_A_V "../tv/cdatafile/c.XMC_grid_sync.autotvin_Ig_A_V.dat"
#define AUTOTB_TVOUT_Ig_A_V "../tv/cdatafile/c.XMC_grid_sync.autotvout_Ig_A_V.dat"
#define WRAPC_STREAM_SIZE_IN_Ig_A_V "../tv/stream_size/stream_size_in_Ig_A_V.dat"
#define WRAPC_STREAM_INGRESS_STATUS_Ig_A_V "../tv/stream_size/stream_ingress_status_Ig_A_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ig_B_V "../tv/cdatafile/c.XMC_grid_sync.autotvin_Ig_B_V.dat"
#define AUTOTB_TVOUT_Ig_B_V "../tv/cdatafile/c.XMC_grid_sync.autotvout_Ig_B_V.dat"
#define WRAPC_STREAM_SIZE_IN_Ig_B_V "../tv/stream_size/stream_size_in_Ig_B_V.dat"
#define WRAPC_STREAM_INGRESS_STATUS_Ig_B_V "../tv/stream_size/stream_ingress_status_Ig_B_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ig_C_V "../tv/cdatafile/c.XMC_grid_sync.autotvin_Ig_C_V.dat"
#define AUTOTB_TVOUT_Ig_C_V "../tv/cdatafile/c.XMC_grid_sync.autotvout_Ig_C_V.dat"
#define WRAPC_STREAM_SIZE_IN_Ig_C_V "../tv/stream_size/stream_size_in_Ig_C_V.dat"
#define WRAPC_STREAM_INGRESS_STATUS_Ig_C_V "../tv/stream_size/stream_ingress_status_Ig_C_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ug_A_V "../tv/cdatafile/c.XMC_grid_sync.autotvin_Ug_A_V.dat"
#define AUTOTB_TVOUT_Ug_A_V "../tv/cdatafile/c.XMC_grid_sync.autotvout_Ug_A_V.dat"
#define WRAPC_STREAM_SIZE_IN_Ug_A_V "../tv/stream_size/stream_size_in_Ug_A_V.dat"
#define WRAPC_STREAM_INGRESS_STATUS_Ug_A_V "../tv/stream_size/stream_ingress_status_Ug_A_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ug_B_V "../tv/cdatafile/c.XMC_grid_sync.autotvin_Ug_B_V.dat"
#define AUTOTB_TVOUT_Ug_B_V "../tv/cdatafile/c.XMC_grid_sync.autotvout_Ug_B_V.dat"
#define WRAPC_STREAM_SIZE_IN_Ug_B_V "../tv/stream_size/stream_size_in_Ug_B_V.dat"
#define WRAPC_STREAM_INGRESS_STATUS_Ug_B_V "../tv/stream_size/stream_ingress_status_Ug_B_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ug_C_V "../tv/cdatafile/c.XMC_grid_sync.autotvin_Ug_C_V.dat"
#define AUTOTB_TVOUT_Ug_C_V "../tv/cdatafile/c.XMC_grid_sync.autotvout_Ug_C_V.dat"
#define WRAPC_STREAM_SIZE_IN_Ug_C_V "../tv/stream_size/stream_size_in_Ug_C_V.dat"
#define WRAPC_STREAM_INGRESS_STATUS_Ug_C_V "../tv/stream_size/stream_ingress_status_Ug_C_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ts_V "../tv/cdatafile/c.XMC_grid_sync.autotvin_Ts_V.dat"
#define AUTOTB_TVOUT_Ts_V "../tv/cdatafile/c.XMC_grid_sync.autotvout_Ts_V.dat"
#define WRAPC_STREAM_SIZE_IN_Ts_V "../tv/stream_size/stream_size_in_Ts_V.dat"
#define WRAPC_STREAM_INGRESS_STATUS_Ts_V "../tv/stream_size/stream_ingress_status_Ts_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ig_d_V "../tv/cdatafile/c.XMC_grid_sync.autotvin_Ig_d_V.dat"
#define AUTOTB_TVOUT_Ig_d_V "../tv/cdatafile/c.XMC_grid_sync.autotvout_Ig_d_V.dat"
#define WRAPC_STREAM_SIZE_OUT_Ig_d_V "../tv/stream_size/stream_size_out_Ig_d_V.dat"
#define WRAPC_STREAM_EGRESS_STATUS_Ig_d_V "../tv/stream_size/stream_egress_status_Ig_d_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ig_q_V "../tv/cdatafile/c.XMC_grid_sync.autotvin_Ig_q_V.dat"
#define AUTOTB_TVOUT_Ig_q_V "../tv/cdatafile/c.XMC_grid_sync.autotvout_Ig_q_V.dat"
#define WRAPC_STREAM_SIZE_OUT_Ig_q_V "../tv/stream_size/stream_size_out_Ig_q_V.dat"
#define WRAPC_STREAM_EGRESS_STATUS_Ig_q_V "../tv/stream_size/stream_egress_status_Ig_q_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ig_zero_V "../tv/cdatafile/c.XMC_grid_sync.autotvin_Ig_zero_V.dat"
#define AUTOTB_TVOUT_Ig_zero_V "../tv/cdatafile/c.XMC_grid_sync.autotvout_Ig_zero_V.dat"
#define WRAPC_STREAM_SIZE_OUT_Ig_zero_V "../tv/stream_size/stream_size_out_Ig_zero_V.dat"
#define WRAPC_STREAM_EGRESS_STATUS_Ig_zero_V "../tv/stream_size/stream_egress_status_Ig_zero_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ug_d_V "../tv/cdatafile/c.XMC_grid_sync.autotvin_Ug_d_V.dat"
#define AUTOTB_TVOUT_Ug_d_V "../tv/cdatafile/c.XMC_grid_sync.autotvout_Ug_d_V.dat"
#define WRAPC_STREAM_SIZE_OUT_Ug_d_V "../tv/stream_size/stream_size_out_Ug_d_V.dat"
#define WRAPC_STREAM_EGRESS_STATUS_Ug_d_V "../tv/stream_size/stream_egress_status_Ug_d_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ug_q_V "../tv/cdatafile/c.XMC_grid_sync.autotvin_Ug_q_V.dat"
#define AUTOTB_TVOUT_Ug_q_V "../tv/cdatafile/c.XMC_grid_sync.autotvout_Ug_q_V.dat"
#define WRAPC_STREAM_SIZE_OUT_Ug_q_V "../tv/stream_size/stream_size_out_Ug_q_V.dat"
#define WRAPC_STREAM_EGRESS_STATUS_Ug_q_V "../tv/stream_size/stream_egress_status_Ug_q_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ug_zero_V "../tv/cdatafile/c.XMC_grid_sync.autotvin_Ug_zero_V.dat"
#define AUTOTB_TVOUT_Ug_zero_V "../tv/cdatafile/c.XMC_grid_sync.autotvout_Ug_zero_V.dat"
#define WRAPC_STREAM_SIZE_OUT_Ug_zero_V "../tv/stream_size/stream_size_out_Ug_zero_V.dat"
#define WRAPC_STREAM_EGRESS_STATUS_Ug_zero_V "../tv/stream_size/stream_egress_status_Ug_zero_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_theta_V "../tv/cdatafile/c.XMC_grid_sync.autotvin_theta_V.dat"
#define AUTOTB_TVOUT_theta_V "../tv/cdatafile/c.XMC_grid_sync.autotvout_theta_V.dat"
#define WRAPC_STREAM_SIZE_OUT_theta_V "../tv/stream_size/stream_size_out_theta_V.dat"
#define WRAPC_STREAM_EGRESS_STATUS_theta_V "../tv/stream_size/stream_egress_status_theta_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_freq_V "../tv/cdatafile/c.XMC_grid_sync.autotvin_freq_V.dat"
#define AUTOTB_TVOUT_freq_V "../tv/cdatafile/c.XMC_grid_sync.autotvout_freq_V.dat"
#define WRAPC_STREAM_SIZE_OUT_freq_V "../tv/stream_size/stream_size_out_freq_V.dat"
#define WRAPC_STREAM_EGRESS_STATUS_freq_V "../tv/stream_size/stream_egress_status_freq_V.dat"

#define INTER_TCL "../tv/cdatafile/ref.tcl"

// tvout file define:
#define AUTOTB_TVOUT_PC_Ig_A_V "../tv/rtldatafile/rtl.XMC_grid_sync.autotvout_Ig_A_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ig_B_V "../tv/rtldatafile/rtl.XMC_grid_sync.autotvout_Ig_B_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ig_C_V "../tv/rtldatafile/rtl.XMC_grid_sync.autotvout_Ig_C_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ug_A_V "../tv/rtldatafile/rtl.XMC_grid_sync.autotvout_Ug_A_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ug_B_V "../tv/rtldatafile/rtl.XMC_grid_sync.autotvout_Ug_B_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ug_C_V "../tv/rtldatafile/rtl.XMC_grid_sync.autotvout_Ug_C_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ts_V "../tv/rtldatafile/rtl.XMC_grid_sync.autotvout_Ts_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ig_d_V "../tv/rtldatafile/rtl.XMC_grid_sync.autotvout_Ig_d_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ig_q_V "../tv/rtldatafile/rtl.XMC_grid_sync.autotvout_Ig_q_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ig_zero_V "../tv/rtldatafile/rtl.XMC_grid_sync.autotvout_Ig_zero_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ug_d_V "../tv/rtldatafile/rtl.XMC_grid_sync.autotvout_Ug_d_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ug_q_V "../tv/rtldatafile/rtl.XMC_grid_sync.autotvout_Ug_q_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ug_zero_V "../tv/rtldatafile/rtl.XMC_grid_sync.autotvout_Ug_zero_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_theta_V "../tv/rtldatafile/rtl.XMC_grid_sync.autotvout_theta_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_freq_V "../tv/rtldatafile/rtl.XMC_grid_sync.autotvout_freq_V.dat"

class INTER_TCL_FILE {
  public:
INTER_TCL_FILE(const char* name) {
  mName = name; 
  Ig_A_V_depth = 0;
  Ig_B_V_depth = 0;
  Ig_C_V_depth = 0;
  Ug_A_V_depth = 0;
  Ug_B_V_depth = 0;
  Ug_C_V_depth = 0;
  Ts_V_depth = 0;
  Ig_d_V_depth = 0;
  Ig_q_V_depth = 0;
  Ig_zero_V_depth = 0;
  Ug_d_V_depth = 0;
  Ug_q_V_depth = 0;
  Ug_zero_V_depth = 0;
  theta_V_depth = 0;
  freq_V_depth = 0;
  trans_num =0;
}
~INTER_TCL_FILE() {
  mFile.open(mName);
  if (!mFile.good()) {
    cout << "Failed to open file ref.tcl" << endl;
    exit (1); 
  }
  string total_list = get_depth_list();
  mFile << "set depth_list {\n";
  mFile << total_list;
  mFile << "}\n";
  mFile << "set trans_num "<<trans_num<<endl;
  mFile.close();
}
string get_depth_list () {
  stringstream total_list;
  total_list << "{Ig_A_V " << Ig_A_V_depth << "}\n";
  total_list << "{Ig_B_V " << Ig_B_V_depth << "}\n";
  total_list << "{Ig_C_V " << Ig_C_V_depth << "}\n";
  total_list << "{Ug_A_V " << Ug_A_V_depth << "}\n";
  total_list << "{Ug_B_V " << Ug_B_V_depth << "}\n";
  total_list << "{Ug_C_V " << Ug_C_V_depth << "}\n";
  total_list << "{Ts_V " << Ts_V_depth << "}\n";
  total_list << "{Ig_d_V " << Ig_d_V_depth << "}\n";
  total_list << "{Ig_q_V " << Ig_q_V_depth << "}\n";
  total_list << "{Ig_zero_V " << Ig_zero_V_depth << "}\n";
  total_list << "{Ug_d_V " << Ug_d_V_depth << "}\n";
  total_list << "{Ug_q_V " << Ug_q_V_depth << "}\n";
  total_list << "{Ug_zero_V " << Ug_zero_V_depth << "}\n";
  total_list << "{theta_V " << theta_V_depth << "}\n";
  total_list << "{freq_V " << freq_V_depth << "}\n";
  return total_list.str();
}
void set_num (int num , int* class_num) {
  (*class_num) = (*class_num) > num ? (*class_num) : num;
}
void set_string(std::string list, std::string* class_list) {
  (*class_list) = list;
}
  public:
    int Ig_A_V_depth;
    int Ig_B_V_depth;
    int Ig_C_V_depth;
    int Ug_A_V_depth;
    int Ug_B_V_depth;
    int Ug_C_V_depth;
    int Ts_V_depth;
    int Ig_d_V_depth;
    int Ig_q_V_depth;
    int Ig_zero_V_depth;
    int Ug_d_V_depth;
    int Ug_q_V_depth;
    int Ug_zero_V_depth;
    int theta_V_depth;
    int freq_V_depth;
    int trans_num;
  private:
    ofstream mFile;
    const char* mName;
};

static void RTLOutputCheckAndReplacement(std::string &AESL_token, std::string PortName) {
  bool no_x = false;
  bool err = false;

  no_x = false;
  // search and replace 'X' with '0' from the 3rd char of token
  while (!no_x) {
    size_t x_found = AESL_token.find('X', 0);
    if (x_found != string::npos) {
      if (!err) { 
        cerr << "WARNING: [SIM 212-201] RTL produces unknown value 'X' on port" 
             << PortName << ", possible cause: There are uninitialized variables in the C design."
             << endl; 
        err = true;
      }
      AESL_token.replace(x_found, 1, "0");
    } else
      no_x = true;
  }
  no_x = false;
  // search and replace 'x' with '0' from the 3rd char of token
  while (!no_x) {
    size_t x_found = AESL_token.find('x', 2);
    if (x_found != string::npos) {
      if (!err) { 
        cerr << "WARNING: [SIM 212-201] RTL produces unknown value 'x' on port" 
             << PortName << ", possible cause: There are uninitialized variables in the C design."
             << endl; 
        err = true;
      }
      AESL_token.replace(x_found, 1, "0");
    } else
      no_x = true;
  }
}
extern "C" void XMC_grid_sync_hw_stub_wrapper(volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *);

extern "C" void apatb_XMC_grid_sync_hw(volatile void * __xlx_apatb_param_Ig_A, volatile void * __xlx_apatb_param_Ig_B, volatile void * __xlx_apatb_param_Ig_C, volatile void * __xlx_apatb_param_Ug_A, volatile void * __xlx_apatb_param_Ug_B, volatile void * __xlx_apatb_param_Ug_C, volatile void * __xlx_apatb_param_Ts, volatile void * __xlx_apatb_param_Ig_d, volatile void * __xlx_apatb_param_Ig_q, volatile void * __xlx_apatb_param_Ig_zero, volatile void * __xlx_apatb_param_Ug_d, volatile void * __xlx_apatb_param_Ug_q, volatile void * __xlx_apatb_param_Ug_zero, volatile void * __xlx_apatb_param_theta, volatile void * __xlx_apatb_param_freq) {
  refine_signal_handler();
  fstream wrapc_switch_file_token;
  wrapc_switch_file_token.open(".hls_cosim_wrapc_switch.log");
  int AESL_i;
  if (wrapc_switch_file_token.good())
  {

    CodeState = ENTER_WRAPC_PC;
    static unsigned AESL_transaction_pc = 0;
    string AESL_token;
    string AESL_num;long __xlx_apatb_param_Ig_A_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_IN_Ig_A_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ig_A_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  for (long i = 0; i < __xlx_apatb_param_Ig_A_V_stream_buf_final_size; ++i)((hls::stream<float>*)__xlx_apatb_param_Ig_A)->read();
long __xlx_apatb_param_Ig_B_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_IN_Ig_B_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ig_B_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  for (long i = 0; i < __xlx_apatb_param_Ig_B_V_stream_buf_final_size; ++i)((hls::stream<float>*)__xlx_apatb_param_Ig_B)->read();
long __xlx_apatb_param_Ig_C_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_IN_Ig_C_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ig_C_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  for (long i = 0; i < __xlx_apatb_param_Ig_C_V_stream_buf_final_size; ++i)((hls::stream<float>*)__xlx_apatb_param_Ig_C)->read();
long __xlx_apatb_param_Ug_A_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_IN_Ug_A_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ug_A_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  for (long i = 0; i < __xlx_apatb_param_Ug_A_V_stream_buf_final_size; ++i)((hls::stream<float>*)__xlx_apatb_param_Ug_A)->read();
long __xlx_apatb_param_Ug_B_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_IN_Ug_B_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ug_B_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  for (long i = 0; i < __xlx_apatb_param_Ug_B_V_stream_buf_final_size; ++i)((hls::stream<float>*)__xlx_apatb_param_Ug_B)->read();
long __xlx_apatb_param_Ug_C_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_IN_Ug_C_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ug_C_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  for (long i = 0; i < __xlx_apatb_param_Ug_C_V_stream_buf_final_size; ++i)((hls::stream<float>*)__xlx_apatb_param_Ug_C)->read();
long __xlx_apatb_param_Ts_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_IN_Ts_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ts_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  for (long i = 0; i < __xlx_apatb_param_Ts_V_stream_buf_final_size; ++i)((hls::stream<float>*)__xlx_apatb_param_Ts)->read();
long __xlx_apatb_param_Ig_d_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_OUT_Ig_d_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ig_d_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  {
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(AUTOTB_TVOUT_PC_Ig_d_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          std::vector<sc_bv<32> > Ig_d_V_pc_buffer;
          int i = 0;

          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){

            RTLOutputCheckAndReplacement(AESL_token, "Ig_d_V");
  
            // push token into output port buffer
            if (AESL_token != "") {
              Ig_d_V_pc_buffer.push_back(AESL_token.c_str());
              i++;
            }
  
            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
          if (i > 0) {for (int j = 0, e = i; j != e; ++j) {
float xlx_stream_elt;

            ((int*)&xlx_stream_elt)[0] = Ig_d_V_pc_buffer[j].to_int64();
          ((hls::stream<float>*)__xlx_apatb_param_Ig_d)->write(xlx_stream_elt);
}
}
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  long __xlx_apatb_param_Ig_q_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_OUT_Ig_q_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ig_q_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  {
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(AUTOTB_TVOUT_PC_Ig_q_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          std::vector<sc_bv<32> > Ig_q_V_pc_buffer;
          int i = 0;

          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){

            RTLOutputCheckAndReplacement(AESL_token, "Ig_q_V");
  
            // push token into output port buffer
            if (AESL_token != "") {
              Ig_q_V_pc_buffer.push_back(AESL_token.c_str());
              i++;
            }
  
            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
          if (i > 0) {for (int j = 0, e = i; j != e; ++j) {
float xlx_stream_elt;

            ((int*)&xlx_stream_elt)[0] = Ig_q_V_pc_buffer[j].to_int64();
          ((hls::stream<float>*)__xlx_apatb_param_Ig_q)->write(xlx_stream_elt);
}
}
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  long __xlx_apatb_param_Ig_zero_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_OUT_Ig_zero_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ig_zero_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  {
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(AUTOTB_TVOUT_PC_Ig_zero_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          std::vector<sc_bv<32> > Ig_zero_V_pc_buffer;
          int i = 0;

          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){

            RTLOutputCheckAndReplacement(AESL_token, "Ig_zero_V");
  
            // push token into output port buffer
            if (AESL_token != "") {
              Ig_zero_V_pc_buffer.push_back(AESL_token.c_str());
              i++;
            }
  
            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
          if (i > 0) {for (int j = 0, e = i; j != e; ++j) {
float xlx_stream_elt;

            ((int*)&xlx_stream_elt)[0] = Ig_zero_V_pc_buffer[j].to_int64();
          ((hls::stream<float>*)__xlx_apatb_param_Ig_zero)->write(xlx_stream_elt);
}
}
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  long __xlx_apatb_param_Ug_d_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_OUT_Ug_d_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ug_d_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  {
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(AUTOTB_TVOUT_PC_Ug_d_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          std::vector<sc_bv<32> > Ug_d_V_pc_buffer;
          int i = 0;

          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){

            RTLOutputCheckAndReplacement(AESL_token, "Ug_d_V");
  
            // push token into output port buffer
            if (AESL_token != "") {
              Ug_d_V_pc_buffer.push_back(AESL_token.c_str());
              i++;
            }
  
            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
          if (i > 0) {for (int j = 0, e = i; j != e; ++j) {
float xlx_stream_elt;

            ((int*)&xlx_stream_elt)[0] = Ug_d_V_pc_buffer[j].to_int64();
          ((hls::stream<float>*)__xlx_apatb_param_Ug_d)->write(xlx_stream_elt);
}
}
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  long __xlx_apatb_param_Ug_q_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_OUT_Ug_q_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ug_q_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  {
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(AUTOTB_TVOUT_PC_Ug_q_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          std::vector<sc_bv<32> > Ug_q_V_pc_buffer;
          int i = 0;

          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){

            RTLOutputCheckAndReplacement(AESL_token, "Ug_q_V");
  
            // push token into output port buffer
            if (AESL_token != "") {
              Ug_q_V_pc_buffer.push_back(AESL_token.c_str());
              i++;
            }
  
            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
          if (i > 0) {for (int j = 0, e = i; j != e; ++j) {
float xlx_stream_elt;

            ((int*)&xlx_stream_elt)[0] = Ug_q_V_pc_buffer[j].to_int64();
          ((hls::stream<float>*)__xlx_apatb_param_Ug_q)->write(xlx_stream_elt);
}
}
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  long __xlx_apatb_param_Ug_zero_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_OUT_Ug_zero_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ug_zero_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  {
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(AUTOTB_TVOUT_PC_Ug_zero_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          std::vector<sc_bv<32> > Ug_zero_V_pc_buffer;
          int i = 0;

          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){

            RTLOutputCheckAndReplacement(AESL_token, "Ug_zero_V");
  
            // push token into output port buffer
            if (AESL_token != "") {
              Ug_zero_V_pc_buffer.push_back(AESL_token.c_str());
              i++;
            }
  
            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
          if (i > 0) {for (int j = 0, e = i; j != e; ++j) {
float xlx_stream_elt;

            ((int*)&xlx_stream_elt)[0] = Ug_zero_V_pc_buffer[j].to_int64();
          ((hls::stream<float>*)__xlx_apatb_param_Ug_zero)->write(xlx_stream_elt);
}
}
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  long __xlx_apatb_param_theta_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_OUT_theta_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_theta_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  {
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(AUTOTB_TVOUT_PC_theta_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          std::vector<sc_bv<32> > theta_V_pc_buffer;
          int i = 0;

          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){

            RTLOutputCheckAndReplacement(AESL_token, "theta_V");
  
            // push token into output port buffer
            if (AESL_token != "") {
              theta_V_pc_buffer.push_back(AESL_token.c_str());
              i++;
            }
  
            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
          if (i > 0) {for (int j = 0, e = i; j != e; ++j) {
float xlx_stream_elt;

            ((int*)&xlx_stream_elt)[0] = theta_V_pc_buffer[j].to_int64();
          ((hls::stream<float>*)__xlx_apatb_param_theta)->write(xlx_stream_elt);
}
}
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  long __xlx_apatb_param_freq_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_OUT_freq_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_freq_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  {
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(AUTOTB_TVOUT_PC_freq_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          std::vector<sc_bv<32> > freq_V_pc_buffer;
          int i = 0;

          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){

            RTLOutputCheckAndReplacement(AESL_token, "freq_V");
  
            // push token into output port buffer
            if (AESL_token != "") {
              freq_V_pc_buffer.push_back(AESL_token.c_str());
              i++;
            }
  
            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
          if (i > 0) {for (int j = 0, e = i; j != e; ++j) {
float xlx_stream_elt;

            ((int*)&xlx_stream_elt)[0] = freq_V_pc_buffer[j].to_int64();
          ((hls::stream<float>*)__xlx_apatb_param_freq)->write(xlx_stream_elt);
}
}
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  
    AESL_transaction_pc++;
    return ;
  }
static unsigned AESL_transaction;
static AESL_FILE_HANDLER aesl_fh;
static INTER_TCL_FILE tcl_file(INTER_TCL);
std::vector<char> __xlx_sprintf_buffer(1024);
CodeState = ENTER_WRAPC;
//Ig_A_V
aesl_fh.touch(AUTOTB_TVIN_Ig_A_V);
aesl_fh.touch(AUTOTB_TVOUT_Ig_A_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_IN_Ig_A_V);
aesl_fh.touch(WRAPC_STREAM_INGRESS_STATUS_Ig_A_V);
//Ig_B_V
aesl_fh.touch(AUTOTB_TVIN_Ig_B_V);
aesl_fh.touch(AUTOTB_TVOUT_Ig_B_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_IN_Ig_B_V);
aesl_fh.touch(WRAPC_STREAM_INGRESS_STATUS_Ig_B_V);
//Ig_C_V
aesl_fh.touch(AUTOTB_TVIN_Ig_C_V);
aesl_fh.touch(AUTOTB_TVOUT_Ig_C_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_IN_Ig_C_V);
aesl_fh.touch(WRAPC_STREAM_INGRESS_STATUS_Ig_C_V);
//Ug_A_V
aesl_fh.touch(AUTOTB_TVIN_Ug_A_V);
aesl_fh.touch(AUTOTB_TVOUT_Ug_A_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_IN_Ug_A_V);
aesl_fh.touch(WRAPC_STREAM_INGRESS_STATUS_Ug_A_V);
//Ug_B_V
aesl_fh.touch(AUTOTB_TVIN_Ug_B_V);
aesl_fh.touch(AUTOTB_TVOUT_Ug_B_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_IN_Ug_B_V);
aesl_fh.touch(WRAPC_STREAM_INGRESS_STATUS_Ug_B_V);
//Ug_C_V
aesl_fh.touch(AUTOTB_TVIN_Ug_C_V);
aesl_fh.touch(AUTOTB_TVOUT_Ug_C_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_IN_Ug_C_V);
aesl_fh.touch(WRAPC_STREAM_INGRESS_STATUS_Ug_C_V);
//Ts_V
aesl_fh.touch(AUTOTB_TVIN_Ts_V);
aesl_fh.touch(AUTOTB_TVOUT_Ts_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_IN_Ts_V);
aesl_fh.touch(WRAPC_STREAM_INGRESS_STATUS_Ts_V);
//Ig_d_V
aesl_fh.touch(AUTOTB_TVIN_Ig_d_V);
aesl_fh.touch(AUTOTB_TVOUT_Ig_d_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_OUT_Ig_d_V);
aesl_fh.touch(WRAPC_STREAM_EGRESS_STATUS_Ig_d_V);
//Ig_q_V
aesl_fh.touch(AUTOTB_TVIN_Ig_q_V);
aesl_fh.touch(AUTOTB_TVOUT_Ig_q_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_OUT_Ig_q_V);
aesl_fh.touch(WRAPC_STREAM_EGRESS_STATUS_Ig_q_V);
//Ig_zero_V
aesl_fh.touch(AUTOTB_TVIN_Ig_zero_V);
aesl_fh.touch(AUTOTB_TVOUT_Ig_zero_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_OUT_Ig_zero_V);
aesl_fh.touch(WRAPC_STREAM_EGRESS_STATUS_Ig_zero_V);
//Ug_d_V
aesl_fh.touch(AUTOTB_TVIN_Ug_d_V);
aesl_fh.touch(AUTOTB_TVOUT_Ug_d_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_OUT_Ug_d_V);
aesl_fh.touch(WRAPC_STREAM_EGRESS_STATUS_Ug_d_V);
//Ug_q_V
aesl_fh.touch(AUTOTB_TVIN_Ug_q_V);
aesl_fh.touch(AUTOTB_TVOUT_Ug_q_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_OUT_Ug_q_V);
aesl_fh.touch(WRAPC_STREAM_EGRESS_STATUS_Ug_q_V);
//Ug_zero_V
aesl_fh.touch(AUTOTB_TVIN_Ug_zero_V);
aesl_fh.touch(AUTOTB_TVOUT_Ug_zero_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_OUT_Ug_zero_V);
aesl_fh.touch(WRAPC_STREAM_EGRESS_STATUS_Ug_zero_V);
//theta_V
aesl_fh.touch(AUTOTB_TVIN_theta_V);
aesl_fh.touch(AUTOTB_TVOUT_theta_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_OUT_theta_V);
aesl_fh.touch(WRAPC_STREAM_EGRESS_STATUS_theta_V);
//freq_V
aesl_fh.touch(AUTOTB_TVIN_freq_V);
aesl_fh.touch(AUTOTB_TVOUT_freq_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_OUT_freq_V);
aesl_fh.touch(WRAPC_STREAM_EGRESS_STATUS_freq_V);
CodeState = DUMP_INPUTS;
std::vector<float> __xlx_apatb_param_Ig_A_stream_buf;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ig_A)->empty())
    __xlx_apatb_param_Ig_A_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ig_A)->read());
  for (int i = 0; i < __xlx_apatb_param_Ig_A_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ig_A)->write(__xlx_apatb_param_Ig_A_stream_buf[i]);
  }
long __xlx_apatb_param_Ig_A_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ig_A)->size();
std::vector<float> __xlx_apatb_param_Ig_B_stream_buf;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ig_B)->empty())
    __xlx_apatb_param_Ig_B_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ig_B)->read());
  for (int i = 0; i < __xlx_apatb_param_Ig_B_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ig_B)->write(__xlx_apatb_param_Ig_B_stream_buf[i]);
  }
long __xlx_apatb_param_Ig_B_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ig_B)->size();
std::vector<float> __xlx_apatb_param_Ig_C_stream_buf;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ig_C)->empty())
    __xlx_apatb_param_Ig_C_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ig_C)->read());
  for (int i = 0; i < __xlx_apatb_param_Ig_C_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ig_C)->write(__xlx_apatb_param_Ig_C_stream_buf[i]);
  }
long __xlx_apatb_param_Ig_C_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ig_C)->size();
std::vector<float> __xlx_apatb_param_Ug_A_stream_buf;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ug_A)->empty())
    __xlx_apatb_param_Ug_A_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ug_A)->read());
  for (int i = 0; i < __xlx_apatb_param_Ug_A_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ug_A)->write(__xlx_apatb_param_Ug_A_stream_buf[i]);
  }
long __xlx_apatb_param_Ug_A_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ug_A)->size();
std::vector<float> __xlx_apatb_param_Ug_B_stream_buf;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ug_B)->empty())
    __xlx_apatb_param_Ug_B_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ug_B)->read());
  for (int i = 0; i < __xlx_apatb_param_Ug_B_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ug_B)->write(__xlx_apatb_param_Ug_B_stream_buf[i]);
  }
long __xlx_apatb_param_Ug_B_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ug_B)->size();
std::vector<float> __xlx_apatb_param_Ug_C_stream_buf;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ug_C)->empty())
    __xlx_apatb_param_Ug_C_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ug_C)->read());
  for (int i = 0; i < __xlx_apatb_param_Ug_C_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ug_C)->write(__xlx_apatb_param_Ug_C_stream_buf[i]);
  }
long __xlx_apatb_param_Ug_C_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ug_C)->size();
std::vector<float> __xlx_apatb_param_Ts_stream_buf;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ts)->empty())
    __xlx_apatb_param_Ts_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ts)->read());
  for (int i = 0; i < __xlx_apatb_param_Ts_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ts)->write(__xlx_apatb_param_Ts_stream_buf[i]);
  }
long __xlx_apatb_param_Ts_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ts)->size();
std::vector<float> __xlx_apatb_param_Ig_d_stream_buf;
long __xlx_apatb_param_Ig_d_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ig_d)->size();
std::vector<float> __xlx_apatb_param_Ig_q_stream_buf;
long __xlx_apatb_param_Ig_q_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ig_q)->size();
std::vector<float> __xlx_apatb_param_Ig_zero_stream_buf;
long __xlx_apatb_param_Ig_zero_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ig_zero)->size();
std::vector<float> __xlx_apatb_param_Ug_d_stream_buf;
long __xlx_apatb_param_Ug_d_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ug_d)->size();
std::vector<float> __xlx_apatb_param_Ug_q_stream_buf;
long __xlx_apatb_param_Ug_q_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ug_q)->size();
std::vector<float> __xlx_apatb_param_Ug_zero_stream_buf;
long __xlx_apatb_param_Ug_zero_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ug_zero)->size();
std::vector<float> __xlx_apatb_param_theta_stream_buf;
long __xlx_apatb_param_theta_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_theta)->size();
std::vector<float> __xlx_apatb_param_freq_stream_buf;
long __xlx_apatb_param_freq_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_freq)->size();
CodeState = CALL_C_DUT;
XMC_grid_sync_hw_stub_wrapper(__xlx_apatb_param_Ig_A, __xlx_apatb_param_Ig_B, __xlx_apatb_param_Ig_C, __xlx_apatb_param_Ug_A, __xlx_apatb_param_Ug_B, __xlx_apatb_param_Ug_C, __xlx_apatb_param_Ts, __xlx_apatb_param_Ig_d, __xlx_apatb_param_Ig_q, __xlx_apatb_param_Ig_zero, __xlx_apatb_param_Ug_d, __xlx_apatb_param_Ug_q, __xlx_apatb_param_Ug_zero, __xlx_apatb_param_theta, __xlx_apatb_param_freq);
CodeState = DUMP_OUTPUTS;
long __xlx_apatb_param_Ig_A_stream_buf_final_size = __xlx_apatb_param_Ig_A_stream_buf_size - ((hls::stream<float>*)__xlx_apatb_param_Ig_A)->size();
// print Ig_A_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVIN_Ig_A_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_A_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv_hw;
sc_bv<32> __xlx_tmp_lv;
__xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ig_A_stream_buf[j])[0];
__xlx_tmp_lv_hw = __xlx_tmp_lv;

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv_hw.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVIN_Ig_A_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ig_A_stream_buf_final_size, &tcl_file.Ig_A_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVIN_Ig_A_V, __xlx_sprintf_buffer.data());
}

// dump stream ingress status to file
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_A_V, __xlx_sprintf_buffer.data());
  if (__xlx_apatb_param_Ig_A_stream_buf_final_size > 0) {
  long Ig_A_V_stream_ingress_size = __xlx_apatb_param_Ig_A_stream_buf_size;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_A_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_A_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_A_stream_buf_final_size; j != e; j++) {
    Ig_A_V_stream_ingress_size--;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_A_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_A_V, __xlx_sprintf_buffer.data());
  }
} else {
  long Ig_A_V_stream_ingress_size = 0;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_A_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_A_V, __xlx_sprintf_buffer.data());
}

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_A_V, __xlx_sprintf_buffer.data());
}{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_A_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ig_A_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_A_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_A_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ig_B_stream_buf_final_size = __xlx_apatb_param_Ig_B_stream_buf_size - ((hls::stream<float>*)__xlx_apatb_param_Ig_B)->size();
// print Ig_B_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVIN_Ig_B_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_B_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv_hw;
sc_bv<32> __xlx_tmp_lv;
__xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ig_B_stream_buf[j])[0];
__xlx_tmp_lv_hw = __xlx_tmp_lv;

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv_hw.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVIN_Ig_B_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ig_B_stream_buf_final_size, &tcl_file.Ig_B_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVIN_Ig_B_V, __xlx_sprintf_buffer.data());
}

// dump stream ingress status to file
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_B_V, __xlx_sprintf_buffer.data());
  if (__xlx_apatb_param_Ig_B_stream_buf_final_size > 0) {
  long Ig_B_V_stream_ingress_size = __xlx_apatb_param_Ig_B_stream_buf_size;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_B_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_B_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_B_stream_buf_final_size; j != e; j++) {
    Ig_B_V_stream_ingress_size--;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_B_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_B_V, __xlx_sprintf_buffer.data());
  }
} else {
  long Ig_B_V_stream_ingress_size = 0;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_B_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_B_V, __xlx_sprintf_buffer.data());
}

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_B_V, __xlx_sprintf_buffer.data());
}{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_B_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ig_B_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_B_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_B_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ig_C_stream_buf_final_size = __xlx_apatb_param_Ig_C_stream_buf_size - ((hls::stream<float>*)__xlx_apatb_param_Ig_C)->size();
// print Ig_C_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVIN_Ig_C_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_C_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv_hw;
sc_bv<32> __xlx_tmp_lv;
__xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ig_C_stream_buf[j])[0];
__xlx_tmp_lv_hw = __xlx_tmp_lv;

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv_hw.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVIN_Ig_C_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ig_C_stream_buf_final_size, &tcl_file.Ig_C_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVIN_Ig_C_V, __xlx_sprintf_buffer.data());
}

// dump stream ingress status to file
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_C_V, __xlx_sprintf_buffer.data());
  if (__xlx_apatb_param_Ig_C_stream_buf_final_size > 0) {
  long Ig_C_V_stream_ingress_size = __xlx_apatb_param_Ig_C_stream_buf_size;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_C_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_C_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_C_stream_buf_final_size; j != e; j++) {
    Ig_C_V_stream_ingress_size--;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_C_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_C_V, __xlx_sprintf_buffer.data());
  }
} else {
  long Ig_C_V_stream_ingress_size = 0;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_C_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_C_V, __xlx_sprintf_buffer.data());
}

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_C_V, __xlx_sprintf_buffer.data());
}{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_C_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ig_C_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_C_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_C_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ug_A_stream_buf_final_size = __xlx_apatb_param_Ug_A_stream_buf_size - ((hls::stream<float>*)__xlx_apatb_param_Ug_A)->size();
// print Ug_A_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVIN_Ug_A_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ug_A_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv_hw;
sc_bv<32> __xlx_tmp_lv;
__xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ug_A_stream_buf[j])[0];
__xlx_tmp_lv_hw = __xlx_tmp_lv;

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv_hw.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVIN_Ug_A_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ug_A_stream_buf_final_size, &tcl_file.Ug_A_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVIN_Ug_A_V, __xlx_sprintf_buffer.data());
}

// dump stream ingress status to file
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_A_V, __xlx_sprintf_buffer.data());
  if (__xlx_apatb_param_Ug_A_stream_buf_final_size > 0) {
  long Ug_A_V_stream_ingress_size = __xlx_apatb_param_Ug_A_stream_buf_size;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ug_A_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_A_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ug_A_stream_buf_final_size; j != e; j++) {
    Ug_A_V_stream_ingress_size--;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ug_A_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_A_V, __xlx_sprintf_buffer.data());
  }
} else {
  long Ug_A_V_stream_ingress_size = 0;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ug_A_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_A_V, __xlx_sprintf_buffer.data());
}

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_A_V, __xlx_sprintf_buffer.data());
}{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ug_A_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ug_A_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ug_A_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ug_A_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ug_B_stream_buf_final_size = __xlx_apatb_param_Ug_B_stream_buf_size - ((hls::stream<float>*)__xlx_apatb_param_Ug_B)->size();
// print Ug_B_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVIN_Ug_B_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ug_B_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv_hw;
sc_bv<32> __xlx_tmp_lv;
__xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ug_B_stream_buf[j])[0];
__xlx_tmp_lv_hw = __xlx_tmp_lv;

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv_hw.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVIN_Ug_B_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ug_B_stream_buf_final_size, &tcl_file.Ug_B_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVIN_Ug_B_V, __xlx_sprintf_buffer.data());
}

// dump stream ingress status to file
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_B_V, __xlx_sprintf_buffer.data());
  if (__xlx_apatb_param_Ug_B_stream_buf_final_size > 0) {
  long Ug_B_V_stream_ingress_size = __xlx_apatb_param_Ug_B_stream_buf_size;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ug_B_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_B_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ug_B_stream_buf_final_size; j != e; j++) {
    Ug_B_V_stream_ingress_size--;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ug_B_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_B_V, __xlx_sprintf_buffer.data());
  }
} else {
  long Ug_B_V_stream_ingress_size = 0;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ug_B_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_B_V, __xlx_sprintf_buffer.data());
}

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_B_V, __xlx_sprintf_buffer.data());
}{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ug_B_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ug_B_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ug_B_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ug_B_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ug_C_stream_buf_final_size = __xlx_apatb_param_Ug_C_stream_buf_size - ((hls::stream<float>*)__xlx_apatb_param_Ug_C)->size();
// print Ug_C_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVIN_Ug_C_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ug_C_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv_hw;
sc_bv<32> __xlx_tmp_lv;
__xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ug_C_stream_buf[j])[0];
__xlx_tmp_lv_hw = __xlx_tmp_lv;

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv_hw.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVIN_Ug_C_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ug_C_stream_buf_final_size, &tcl_file.Ug_C_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVIN_Ug_C_V, __xlx_sprintf_buffer.data());
}

// dump stream ingress status to file
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_C_V, __xlx_sprintf_buffer.data());
  if (__xlx_apatb_param_Ug_C_stream_buf_final_size > 0) {
  long Ug_C_V_stream_ingress_size = __xlx_apatb_param_Ug_C_stream_buf_size;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ug_C_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_C_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ug_C_stream_buf_final_size; j != e; j++) {
    Ug_C_V_stream_ingress_size--;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ug_C_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_C_V, __xlx_sprintf_buffer.data());
  }
} else {
  long Ug_C_V_stream_ingress_size = 0;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ug_C_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_C_V, __xlx_sprintf_buffer.data());
}

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_C_V, __xlx_sprintf_buffer.data());
}{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ug_C_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ug_C_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ug_C_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ug_C_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ts_stream_buf_final_size = __xlx_apatb_param_Ts_stream_buf_size - ((hls::stream<float>*)__xlx_apatb_param_Ts)->size();
// print Ts_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVIN_Ts_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ts_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv_hw;
sc_bv<32> __xlx_tmp_lv;
__xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ts_stream_buf[j])[0];
__xlx_tmp_lv_hw = __xlx_tmp_lv;

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv_hw.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVIN_Ts_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ts_stream_buf_final_size, &tcl_file.Ts_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVIN_Ts_V, __xlx_sprintf_buffer.data());
}

// dump stream ingress status to file
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ts_V, __xlx_sprintf_buffer.data());
  if (__xlx_apatb_param_Ts_stream_buf_final_size > 0) {
  long Ts_V_stream_ingress_size = __xlx_apatb_param_Ts_stream_buf_size;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ts_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ts_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ts_stream_buf_final_size; j != e; j++) {
    Ts_V_stream_ingress_size--;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ts_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ts_V, __xlx_sprintf_buffer.data());
  }
} else {
  long Ts_V_stream_ingress_size = 0;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ts_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ts_V, __xlx_sprintf_buffer.data());
}

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ts_V, __xlx_sprintf_buffer.data());
}{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ts_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ts_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ts_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ts_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ig_d_stream_buf_final_size = ((hls::stream<float>*)__xlx_apatb_param_Ig_d)->size() - __xlx_apatb_param_Ig_d_stream_buf_size;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ig_d)->empty())
    __xlx_apatb_param_Ig_d_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ig_d)->read());
  for (int i = 0; i < __xlx_apatb_param_Ig_d_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ig_d)->write(__xlx_apatb_param_Ig_d_stream_buf[i]);
  }
// print Ig_d_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVOUT_Ig_d_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_d_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ig_d_stream_buf[__xlx_apatb_param_Ig_d_stream_buf_size+j])[0];

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVOUT_Ig_d_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ig_d_stream_buf_final_size, &tcl_file.Ig_d_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVOUT_Ig_d_V, __xlx_sprintf_buffer.data());
}
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ig_d_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ig_d_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ig_d_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ig_d_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ig_q_stream_buf_final_size = ((hls::stream<float>*)__xlx_apatb_param_Ig_q)->size() - __xlx_apatb_param_Ig_q_stream_buf_size;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ig_q)->empty())
    __xlx_apatb_param_Ig_q_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ig_q)->read());
  for (int i = 0; i < __xlx_apatb_param_Ig_q_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ig_q)->write(__xlx_apatb_param_Ig_q_stream_buf[i]);
  }
// print Ig_q_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVOUT_Ig_q_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_q_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ig_q_stream_buf[__xlx_apatb_param_Ig_q_stream_buf_size+j])[0];

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVOUT_Ig_q_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ig_q_stream_buf_final_size, &tcl_file.Ig_q_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVOUT_Ig_q_V, __xlx_sprintf_buffer.data());
}
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ig_q_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ig_q_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ig_q_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ig_q_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ig_zero_stream_buf_final_size = ((hls::stream<float>*)__xlx_apatb_param_Ig_zero)->size() - __xlx_apatb_param_Ig_zero_stream_buf_size;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ig_zero)->empty())
    __xlx_apatb_param_Ig_zero_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ig_zero)->read());
  for (int i = 0; i < __xlx_apatb_param_Ig_zero_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ig_zero)->write(__xlx_apatb_param_Ig_zero_stream_buf[i]);
  }
// print Ig_zero_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVOUT_Ig_zero_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_zero_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ig_zero_stream_buf[__xlx_apatb_param_Ig_zero_stream_buf_size+j])[0];

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVOUT_Ig_zero_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ig_zero_stream_buf_final_size, &tcl_file.Ig_zero_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVOUT_Ig_zero_V, __xlx_sprintf_buffer.data());
}
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ig_zero_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ig_zero_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ig_zero_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ig_zero_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ug_d_stream_buf_final_size = ((hls::stream<float>*)__xlx_apatb_param_Ug_d)->size() - __xlx_apatb_param_Ug_d_stream_buf_size;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ug_d)->empty())
    __xlx_apatb_param_Ug_d_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ug_d)->read());
  for (int i = 0; i < __xlx_apatb_param_Ug_d_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ug_d)->write(__xlx_apatb_param_Ug_d_stream_buf[i]);
  }
// print Ug_d_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVOUT_Ug_d_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ug_d_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ug_d_stream_buf[__xlx_apatb_param_Ug_d_stream_buf_size+j])[0];

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVOUT_Ug_d_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ug_d_stream_buf_final_size, &tcl_file.Ug_d_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVOUT_Ug_d_V, __xlx_sprintf_buffer.data());
}
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ug_d_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ug_d_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ug_d_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ug_d_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ug_q_stream_buf_final_size = ((hls::stream<float>*)__xlx_apatb_param_Ug_q)->size() - __xlx_apatb_param_Ug_q_stream_buf_size;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ug_q)->empty())
    __xlx_apatb_param_Ug_q_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ug_q)->read());
  for (int i = 0; i < __xlx_apatb_param_Ug_q_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ug_q)->write(__xlx_apatb_param_Ug_q_stream_buf[i]);
  }
// print Ug_q_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVOUT_Ug_q_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ug_q_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ug_q_stream_buf[__xlx_apatb_param_Ug_q_stream_buf_size+j])[0];

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVOUT_Ug_q_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ug_q_stream_buf_final_size, &tcl_file.Ug_q_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVOUT_Ug_q_V, __xlx_sprintf_buffer.data());
}
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ug_q_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ug_q_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ug_q_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ug_q_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ug_zero_stream_buf_final_size = ((hls::stream<float>*)__xlx_apatb_param_Ug_zero)->size() - __xlx_apatb_param_Ug_zero_stream_buf_size;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ug_zero)->empty())
    __xlx_apatb_param_Ug_zero_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ug_zero)->read());
  for (int i = 0; i < __xlx_apatb_param_Ug_zero_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ug_zero)->write(__xlx_apatb_param_Ug_zero_stream_buf[i]);
  }
// print Ug_zero_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVOUT_Ug_zero_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ug_zero_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ug_zero_stream_buf[__xlx_apatb_param_Ug_zero_stream_buf_size+j])[0];

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVOUT_Ug_zero_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ug_zero_stream_buf_final_size, &tcl_file.Ug_zero_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVOUT_Ug_zero_V, __xlx_sprintf_buffer.data());
}
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ug_zero_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ug_zero_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ug_zero_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Ug_zero_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_theta_stream_buf_final_size = ((hls::stream<float>*)__xlx_apatb_param_theta)->size() - __xlx_apatb_param_theta_stream_buf_size;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_theta)->empty())
    __xlx_apatb_param_theta_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_theta)->read());
  for (int i = 0; i < __xlx_apatb_param_theta_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_theta)->write(__xlx_apatb_param_theta_stream_buf[i]);
  }
// print theta_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVOUT_theta_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_theta_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv = ((int*)&__xlx_apatb_param_theta_stream_buf[__xlx_apatb_param_theta_stream_buf_size+j])[0];

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVOUT_theta_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_theta_stream_buf_final_size, &tcl_file.theta_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVOUT_theta_V, __xlx_sprintf_buffer.data());
}
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_theta_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_theta_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_OUT_theta_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_theta_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_freq_stream_buf_final_size = ((hls::stream<float>*)__xlx_apatb_param_freq)->size() - __xlx_apatb_param_freq_stream_buf_size;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_freq)->empty())
    __xlx_apatb_param_freq_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_freq)->read());
  for (int i = 0; i < __xlx_apatb_param_freq_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_freq)->write(__xlx_apatb_param_freq_stream_buf[i]);
  }
// print freq_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVOUT_freq_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_freq_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv = ((int*)&__xlx_apatb_param_freq_stream_buf[__xlx_apatb_param_freq_stream_buf_size+j])[0];

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVOUT_freq_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_freq_stream_buf_final_size, &tcl_file.freq_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVOUT_freq_V, __xlx_sprintf_buffer.data());
}
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_freq_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_freq_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_OUT_freq_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_freq_V, __xlx_sprintf_buffer.data());
}CodeState = DELETE_CHAR_BUFFERS;
AESL_transaction++;
tcl_file.set_num(AESL_transaction , &tcl_file.trans_num);
}
